'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _Compiler2 = require('../Compiler');var _Compiler3 = _interopRequireDefault(_Compiler2);var _CompileResult = require(
'../CompileResult');var _CompileResult2 = _interopRequireDefault(_CompileResult);var _EntryPoint = require(
'../../EntryPoint');var _EntryPoint2 = _interopRequireDefault(_EntryPoint);var _WebpackAssetServer = require(
'./WebpackAssetServer');var _WebpackAssetServer2 = _interopRequireDefault(_WebpackAssetServer);var _defaultFrameworkConfigJs = require(
'../../defaultFrameworkConfig.js');

var path = require('path');
var fs = require('fs');
var rimraf = require('rimraf');
var COMMONS_ENTRY_NAME = '__commons';
var ExtractTextPlugin = require("extract-text-webpack-plugin");

var SOURCE_MAP_FILE_REGEX = /\.[a-zA-Z0-9]{1,4}\.map/;
var CSS_FILE_REGEX = /\.css[\?#]?/;
var JS_FILE_REGEX = /\.js[\?#]?/;

/**
 * @SERVER
 */var 
WebpackCompiler = (function (_Compiler) {_inherits(WebpackCompiler, _Compiler);




























































  /**
   * @param {Logger} logger
   * @param {Object} frameworkConfig
   * @param {any} webpack
   * @param {any} react
   * @param {Function} webpackDevMiddleware
   * @param {Function} webpackHotMiddleware
   */
  function WebpackCompiler(logger, frameworkConfig, webpack, react, 
  webpackDevMiddleware, webpackHotMiddleware) {_classCallCheck(this, WebpackCompiler);
    _get(Object.getPrototypeOf(WebpackCompiler.prototype), 'constructor', this).call(this);
    this._logger = logger;
    this._react = react;
    this._webpack = webpack;
    this._webpackDevMiddleware = webpackDevMiddleware;
    this._webpackHotMiddleware = webpackHotMiddleware;
    this._frameworkConfig = frameworkConfig;
    this._clientReplace = frameworkConfig.clientReplace;
    this._clientResolve = frameworkConfig.clientResolve;
    this._absoluteClientBuildDir = path.join(frameworkConfig.absoluteProjectDir, 'build/client');
    this._assetHostPath = frameworkConfig.assetHostPath;
    this._assetServer = new _WebpackAssetServer2['default'](this._assetHostPath, this._absoluteClientBuildDir, logger);
    this._firstCompileDone = false;

    if (this._frameworkConfig.hotReload && (!webpackDevMiddleware || !webpackHotMiddleware)) {
      throw new Error('Hot reload flag is true, yet webpack dev/hot middleware is not passed to WebpackCompiler.');}


    this._cleanTempDir();}


  /**
   * @param {any} webpack
   * @param {Object} frameworkConfig
   * @returns {Object}
   */_createClass(WebpackCompiler, [{ key: 'getBabelLoaderExtras', 


































































































    /**
     * Only called at client side. Adds babel plugins like react-transform and
     * client resolve operations.
     *
     * @param {Object<string, boolean>} entryPointAbsolutePathMap
     * @return {Object}
     */value: 
    function getBabelLoaderExtras(entryPointAbsolutePathMap) {
      var result = { 
        plugins: [], 
        extra: {} };


      if (this._frameworkConfig.hotReload) {
        result.plugins.push({ 
          transformer: this._createHotModuleAcceptPlugin(entryPointAbsolutePathMap, this._frameworkConfig), 
          position: 'before' });}



      result.plugins.push({ 
        transformer: this._createResolvePlugin(), 
        position: 'after' });


      if (this._frameworkConfig.hotReload) {
        result.plugins.push('react-transform');
        result.extra['react-transform'] = { 
          transforms: [
            //{
            //  'transform': 'react-transform-hmr',
            //  'imports': ['react'],
            //  'locals':  ['module']
            //},
            //{
            //  'transform': 'react-transform-catch-errors',
            //  'imports': ['react', 'redbox-react']
            //}
          ] };}


      return result;} }, { key: 'run', 















    /**
     * 1) Create configuration with one common file for webpack.
     * 2) Compile webpack from source to temporary location, with CSS loader
     *    and file loader.
     * 3) Read all files to AssetServer - AssetServer could just read the
     *    files, but cache everything.
     *
     *    TODO: Make babel optional
     *    TODO: Allow user setting of loaders.
     *
     * @param {Array<EntryPoint>} entryPoints
     * @param {Function} updateCompileResultCallback
     * @return {Array<Function>}
     */value: 
    function run(entryPoints, updateCompileResultCallback) {var _this = this;
      var i, j, entryPoint, entryPointList = [];
      var configuration = { 
        entry: {}, 
        output: { 
          path: this._absoluteClientBuildDir, 
          filename: "[name]-[chunkhash].js", 
          publicPath: this._frameworkConfig.assetProtocol + '://' + this._assetHostPath }, 

        module: { 
          loaders: [
          WebpackCompiler.getBabelLoaderConfig(), 
          WebpackCompiler.getFileLoaderConfig(this._frameworkConfig)], 

          noParse: /node_modules\/quill\/dist/ }, 

        devtool: "source-map", 
        resolve: WebpackCompiler.generateResolveConfig(this._frameworkConfig), 
        plugins: [
        new this._webpack.optimize.OccurenceOrderPlugin()] };



      var cssModuleArgs = JSON.stringify({ 
        sourceMap: true, 
        modules: true, 
        localIdentName: this._frameworkConfig.debug ? '[name]_[local]_[hash:base64:3]' : '[hash:base64]' });


      // Links you need to read to understand this CSS section:
      // - https://webpack.github.io/docs/stylesheets.html
      // - https://github.com/webpack/extract-text-webpack-plugin
      // - https://webpack.github.io/docs/list-of-plugins.html
      // - https://github.com/webpack/css-loader
      // - https://github.com/webpack/style-loader
      var modulesCssLoader = { 
        test: /\.mod\.css$/, 
        loader: 'style-loader!css-loader?' + cssModuleArgs };

      var normalCssLoader = { 
        test: /\.css$/, 
        loader: 'style-loader!css-loader', 
        exclude: /\.mod\.css$/ };

      var modulesScssLoader = { 
        test: /\.mod\.scss$/, 
        loader: 'style-loader!css-loader?' + cssModuleArgs + '!sass-loader' };

      var normalSassLoader = { 
        test: /\.scss$/, 
        loader: 'style-loader!css-loader!sass-loader', 
        exclude: /\.mod\.scss$/ };

      if (!this._frameworkConfig.hotReload) {
        // Enable loading CSS as files.
        modulesCssLoader.loader = ExtractTextPlugin.extract(
        "style-loader", 
        "css-loader?" + cssModuleArgs);

        normalCssLoader.loader = ExtractTextPlugin.extract(
        "style-loader", 
        "css-loader");

        modulesScssLoader.loader = ExtractTextPlugin.extract(
        "style-loader", 
        "css-loader?" + cssModuleArgs + "!sass-loader");

        normalSassLoader.loader = ExtractTextPlugin.extract(
        "style-loader", 
        "css-loader!sass-loader");

        configuration.plugins.push(
        new ExtractTextPlugin('css/[name]-[chunkhash].css'));}

      configuration.module.loaders.push(modulesCssLoader);
      configuration.module.loaders.push(normalCssLoader);
      configuration.module.loaders.push(modulesScssLoader);
      configuration.module.loaders.push(normalSassLoader);

      for (i in this._clientReplace) {
        if (!this._clientReplace.hasOwnProperty(i)) continue;
        configuration.resolve.alias[i] = this._clientReplace[i];}


      if (this._frameworkConfig.hotReload) {
        configuration.plugins.push(new this._webpack.HotModuleReplacementPlugin());}


      configuration.plugins.push(new this._webpack.NoErrorsPlugin());
      configuration.plugins.push(new this._webpack.optimize.CommonsChunkPlugin({ 
        name: COMMONS_ENTRY_NAME, 
        filename: 'common-[hash].js', 
        minChunks: this._frameworkConfig.commonFileThreshold }));


      if (this._frameworkConfig.minifyJs) {
        configuration.plugins.push(new this._webpack.optimize.UglifyJsPlugin({}));}


      // Accept env var
      var definePlugin = new this._webpack.DefinePlugin({ 
        'process.env.NODE_ENV': this._frameworkConfig.NODE_ENV || '"development"' });

      configuration.plugins.push(definePlugin);

      var pageToRequire, entryPointAbsolutePathMap = {};
      for (i = 0; i < entryPoints.length; i++) {
        entryPoint = entryPoints[i];
        pageToRequire = path.join(entryPoint.absolutePath);
        entryPointAbsolutePathMap[pageToRequire] = true;
        configuration.entry[entryPoint.name] = pageToRequire;
        entryPointList.push(entryPoint.name);}


      // Add babel plugins.
      configuration.babel = this.getBabelLoaderExtras(entryPointAbsolutePathMap);

      var compiler = this._webpack(configuration);
      var self = this;

      compiler.plugin('done', function (stats) {
        if (stats.compilation.errors.length > 0) {
          // Error occured. Print error messages.
          _this._printErrorMessages(stats);
          return;}


        var key;
        for (key in entryPointAbsolutePathMap) {
          if (!entryPointAbsolutePathMap.hasOwnProperty(key)) continue;
          entryPointAbsolutePathMap[key] = true;}


        var i, chunkMap = {};
        for (i = 0; i < stats.compilation.chunks.length; i++) {
          chunkMap[stats.compilation.chunks[i].name] = stats.compilation.chunks[i];}

        var commonsChunk = chunkMap[COMMONS_ENTRY_NAME];

        var compileResult = new _CompileResult2['default'](), entryPointChunk, entryPointName, 
        pageDep, depArray;
        for (i = 0; i < entryPointList.length; i++) {
          entryPointName = entryPointList[i];
          if (!chunkMap.hasOwnProperty(entryPointName)) {
            var error = new Error('Unable to determine dependency, entry point ' + entryPointName + ' does not have webpack chunk!');
            if (_this._firstCompileDone) {
              // If this is a webpack hot reload compilation, don't throw the
              // error, just log to the user.
              _this._logger.error('Hot reload ->', error);
              return;}

            throw error;}

          entryPointChunk = chunkMap[entryPointName];

          pageDep = { 
            cssDependencies: [], 
            jsDependencies: [] };


          for (j = 0; j < commonsChunk.files.length; j++) {
            if (SOURCE_MAP_FILE_REGEX.test(commonsChunk.files[j])) continue;
            depArray = CSS_FILE_REGEX.test(commonsChunk.files[j]) ? pageDep.cssDependencies : pageDep.jsDependencies;
            depArray.push(self._assetServer.toUrlWithProtocol(
            commonsChunk.files[j], _this._frameworkConfig.assetProtocol));}


          for (j = 0; j < entryPointChunk.files.length; j++) {
            if (SOURCE_MAP_FILE_REGEX.test(entryPointChunk.files[j])) continue;
            depArray = CSS_FILE_REGEX.test(entryPointChunk.files[j]) ? pageDep.cssDependencies : pageDep.jsDependencies;
            depArray.push(self._assetServer.toUrlWithProtocol(
            entryPointChunk.files[j], _this._frameworkConfig.assetProtocol));}



          compileResult.pages[entryPointName] = pageDep;}


        // Sets the flag, we have completed the very first compilation. Next
        // compilation error should not trigger errors.
        _this._firstCompileDone = true;

        updateCompileResultCallback(compileResult);});


      compiler.plugin('failed', function (err) {
        // Error ocurred. Print error messages.
        _this._printErrorMessages(err);});


      var middlewares = [];

      if (this._frameworkConfig.hotReload) {
        // Let webpack-dev-middleware handles watching, storing output and serving
        // asset requests. Meanwhile, webpack hot middleware should be accepting
        // connection from the client.
        middlewares.push(this._webpackDevMiddleware(compiler, { 
          noInfo: true, 
          publicPath: configuration.output.publicPath }));

        middlewares.push(this._webpackHotMiddleware(compiler));} else 
      {
        // Middleware for regular webpack asset server.
        middlewares.push(function (request, response, next) {
          var handledByAssetServer = _this._assetServer.handle(request, response);
          if (!handledByAssetServer) {
            next();}});



        // We only need to run if we are not hot reloading, since
        // webpack-dev-middleware already runs watch() for us.
        compiler.run(function () {
          // No-op. We'll use the above 'done' and 'failed' hook to notify
          // application for successes and failures.
        });}


      return middlewares;} }, { key: '_cleanTempDir', value: 


    function _cleanTempDir() {
      // Remove everything in the directory.
      rimraf.sync(this._absoluteClientBuildDir);

      // Ensure directory exists.
      try {
        fs.mkdirSync(this._absoluteClientBuildDir);} 
      catch (e) {
        if (e.code != 'EEXIST') throw e;}}



    /**
     * @param {any} stats
     */ }, { key: '_printErrorMessages', value: 
    function _printErrorMessages(stats) {
      if (this._firstCompileDone) {
        // Second compilation is only done when we are using hot reload.
        // We should not stop the server if an exception happens.
        return;}

      var error = new Error('Webpack compilation error!');
      this._logger.error('Webpack compilation error -> ', error, [stats.compilation.errors]);
      throw error;} }, { key: '_createResolvePlugin', value: 



    function _createResolvePlugin() {
      var self = this;
      return function (_ref) {var Plugin = _ref.Plugin;var t = _ref.types;
        return new Plugin("soya-resolve-plugin", { 
          visitor: { 
            CallExpression: function CallExpression(node, parent) {
              if (t.isIdentifier(node.callee, { name: "require" })) {
                var requireValue = node.arguments[0].value;
                if (self._clientResolve) {
                  var i, resolved;
                  for (i = 0; i < self._clientResolve.length; i++) {
                    // TODO: Pass also the absolute path of currently parsed file.
                    resolved = self._clientResolve[i](requireValue);
                    if (resolved != null) {
                      node.arguments[0].value = resolved;
                      return;}}}}} } });};}










    /**
     * @param {Object} frameworkConfig
     * @param {Object<string, boolean>} entryPointAbsolutePathMap
     */ }, { key: '_createHotModuleAcceptPlugin', value: 
    function _createHotModuleAcceptPlugin(entryPointAbsolutePathMap, frameworkConfig) {
      var self = this;
      return function (_ref2) {var Plugin = _ref2.Plugin;var t = _ref2.types;
        return new Plugin("soya-hot-module-accept-plugin", { 
          visitor: { 
            ClassDeclaration: function ClassDeclaration(node, parent) {
              var curFilePath;
              if (frameworkConfig.hotReload) {
                curFilePath = this.scope.hub.file.opts.filename;
                if (entryPointAbsolutePathMap[curFilePath]) {
                  entryPointAbsolutePathMap[curFilePath] = false;
                  this.insertAfter([
                  t.ifStatement(
                  t.memberExpression(t.identifier('module'), t.identifier('hot')), 
                  t.blockStatement([
                  t.expressionStatement(t.callExpression(
                  t.memberExpression(t.memberExpression(t.identifier('module'), t.identifier('hot')), t.identifier('accept')), 
                  [
                  t.functionExpression(null, [], t.blockStatement([
                  t.expressionStatement(t.callExpression(
                  t.memberExpression(t.identifier('console'), t.identifier('error')), 
                  [t.literal('Unable to accept hot reload module!'), t.identifier('arguments')]))]))]))]))]);}}} } });};} }], [{ key: 'createServerBuildConfig', value: function createServerBuildConfig(webpack, frameworkConfig) {frameworkConfig = Object.assign({}, _defaultFrameworkConfigJs.DEFAULT_FRAMEWORK_CONFIG, frameworkConfig);var nodeModules = {};var absProjectDir = frameworkConfig.absoluteProjectDir;var absEntryPointFile = path.join(frameworkConfig.absoluteProjectDir, 'build/precompile/server.js');var absBuildTargetDir = path.join(frameworkConfig.absoluteProjectDir, 'build/server');fs.readdirSync(path.join(absProjectDir, 'node_modules')).filter(function (x) {return ['.bin'].indexOf(x) === -1;}).forEach(function (mod) {nodeModules[mod] = 'commonjs ' + mod;});return { entry: absEntryPointFile, target: 'node', output: { path: absBuildTargetDir, publicPath: frameworkConfig.assetProtocol + '://' + frameworkConfig.assetHostPath, filename: 'index.js' }, node: { __dirname: true, __filename: true }, devtool: 'source-map', module: { loaders: [WebpackCompiler.getBabelLoaderConfig(), WebpackCompiler.getFileLoaderConfig(frameworkConfig), { test: /\.css$/, loader: 'css-loader/locals', exclude: /\.mod\.css/ }, { test: /\.mod\.css$/, loader: 'css-loader/locals?' + JSON.stringify({ sourceMap: true, modules: true, localIdentName: frameworkConfig.debug ? '[name]_[local]_[hash:base64:3]' : '[hash:base64]' }) }, { test: /\.scss$/, loader: 'css-loader/locals!sass-loader', exclude: /\.mod\.scss/ }, { test: /\.mod\.scss$/, loader: 'css-loader/locals?' + JSON.stringify({ sourceMap: true, modules: true, localIdentName: frameworkConfig.debug ? '[name]_[local]_[hash:base64:3]' : '[hash:base64]' }) + '!sass-loader' }] }, plugins: [new webpack.BannerPlugin('require("source-map-support").install();', { raw: true, entryOnly: false }), new webpack.optimize.OccurenceOrderPlugin(), new webpack.NoErrorsPlugin()], resolve: WebpackCompiler.generateResolveConfig(frameworkConfig), externals: nodeModules };} }, { key: 'generateResolveConfig', value: function generateResolveConfig(frameworkConfig) {var absoluteProjectDir = frameworkConfig.absoluteProjectDir;var defaultImportBase = frameworkConfig.defaultImportBase;if (defaultImportBase) {defaultImportBase = path.resolve(absoluteProjectDir, defaultImportBase);} // Removes undefined config if any
      var rootResolves = [absoluteProjectDir, defaultImportBase].filter(function (config) {return !!config;});return { alias: {}, root: rootResolves };} /**
                                                                                                                                                          * @return {Object}
                                                                                                                                                          */ }, { key: 'getBabelLoaderConfig', value: function getBabelLoaderConfig() {var result = { test: /\.jsx?$/, exclude: /(node_modules|bower_components)/, loader: 'babel', query: { optional: ['runtime', 'es7.decorators'], blacklist: [], retainLines: true, comments: false } };return result;} }, { key: 'getFileLoaderConfig', value: function getFileLoaderConfig(config) {var test;if (config.staticAssetRegex) {test = config.staticAssetRegex;} else {test = /(\.jpg|\.png|\.jpeg|\.gif|\.ico|\.(eot|ttf|svg|woff(2)?)(\??#[a-zA-Z0-9]+)?)$/;}return { test: test, loader: "file-loader?name=[name]-[hash].[ext]" };} }]);return WebpackCompiler;})(_Compiler3['default']);exports['default'] = WebpackCompiler;module.exports = exports['default']; /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {{[key: string]: any}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {{[key: string]: string}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {Array<Function>}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {WebpackAssetServer}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        * @type {Logger}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @type {?Function}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @type {?Function}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @type {boolean}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */
//# sourceMappingURL=WebpackCompiler.js.map