/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _StoreJs = require(

'../Store.js');var _StoreJs2 = _interopRequireDefault(_StoreJs);var _PromiseUtilJs = require(
'./PromiseUtil.js');var _PromiseUtilJs2 = _interopRequireDefault(_PromiseUtilJs);var _LoadJs = require(
'./Load.js');var _LoadJs2 = _interopRequireDefault(_LoadJs);var _QueryDependenciesJs = require(
'./QueryDependencies.js');var _QueryDependenciesJs2 = _interopRequireDefault(_QueryDependenciesJs);var _HydrationJs = require(
'./Hydration.js');var _HydrationJs2 = _interopRequireDefault(_HydrationJs);var _QueryResultJs = require(

'./QueryResult.js');var _QueryResultJs2 = _interopRequireDefault(_QueryResultJs);var _redux = require(
'redux');var _reduxDevtools = require(
'redux-devtools');var _reduxThunk = require(
'redux-thunk');var _reduxThunk2 = _interopRequireDefault(_reduxThunk);var _soyaLibScope = require(
'soya/lib/scope');var _soyaLibScope2 = _interopRequireDefault(_soyaLibScope);

/*

type StoreReference = {
  getState: Function;
  unregister: Function;
};

*/

var SUBSCRIBER_ID = '__soyaReduxStoreSubscriberId';
var REPLACE_STATE = '__soyaReplaceState';

/**
 * Creates and wraps redux store. Responsibilities:
 *
 * 1. Wraps redux store's dispatch, reads special Load object and executes its
 *    associated query dependencies.
 * 2. Wraps redux store's subscribe to makes it easier for components to
 *    'connect' or listen to changes to just a specific part of the state instead
 *    of the entire state.
 * 3. Listen to store changes, then asks each segment to decide whether or not
 *    the state has changed considerably to trigger re-rendering on each
 *    subscription.
 * 4. By separating regular actions and load actions performed during query,
 *    makes it easier to perform server side hydration.
 *
 * @CLIENT_SERVER
 */var 
ReduxStore = (function (_Store) {_inherits(ReduxStore, _Store);
















































































































































  /**
   * @param {any} initialState
   * @param {Object} clientConfig
   * @param {CookieJar} cookieJar
   */
  function ReduxStore(initialState, clientConfig, cookieJar) {_classCallCheck(this, ReduxStore);
    _get(Object.getPrototypeOf(ReduxStore.prototype), 'constructor', this).call(this);
    if (initialState == null) {
      initialState = {};}

    this.__isReduxStore = true;
    this._handleChangeCallId = 0;
    this._inHydration = false;
    this._allowRegisterSegment = false;
    this._clientConfig = clientConfig;
    this._segmentClasses = {};
    this._queries = {};
    this._services = {};
    this._serviceClasses = {};
    this._serviceDependencies = {};
    this._registeredQueries = {};
    this._reducers = {};
    this._subscribers = {};
    this._nextSubscriberId = 1;
    this._store = this._createStore(initialState);
    this._store.subscribe(this._handleChange.bind(this));
    this._actionCreators = {};
    this._allowOverwriteSegment = {};
    this._cookieJar = cookieJar;
    this._boundDispatch = this.dispatch.bind(this);
    this._boundQuery = this.query.bind(this);}


  /**
   * Only allow Segment registration at render process.
   */_createClass(ReduxStore, [{ key: '_startRender', value: 
    function _startRender() {
      this._allowRegisterSegment = true;}


    /**
     * Disable segment registration after render process.
     */ }, { key: '_endRender', value: 
    function _endRender() {
      this._allowRegisterSegment = false;}


    /**
     * @param {?Object} initialState
     * @returns {Object}
     */ }, { key: '_createStore', value: 
    function _createStore(initialState) {
      // https://github.com/zalmoxisus/redux-devtools-extension
      // TODO: Probably should be framework config instead of client config?
      var composeEnhancers = _redux.compose;
      if (this._clientConfig.enableDevTools && _soyaLibScope2['default'].client) {
        composeEnhancers = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || _redux.compose;}


      var composedCreateStore = composeEnhancers(
      (0, _redux.applyMiddleware)(_reduxThunk2['default']))(_redux.createStore);

      return composedCreateStore(this._rootReducer.bind(this), initialState);}


    /**
     * Root reducer.
     *
     * TODO: Don't run action on reducers that are not associated with the segment, should be faster, since there'll be less string comparison.
     *
     * @param {void | Object} state
     * @param {any} action
     * @returns {Object}
     * @private
     */ }, { key: '_rootReducer', value: 
    function _rootReducer(state, action) {
      if (state == null) state = {};
      if (action.type === REPLACE_STATE) {
        // Replace state directly.
        return action.state;}


      var reducer, segmentName, segment, segmentState, nextSegmentState;
      var nextState = {}, isChanged = false;
      for (segmentName in state) {
        if (!state.hasOwnProperty(segmentName)) continue;
        nextState[segmentName] = state[segmentName];}


      for (segmentName in this._reducers) {
        if (!this._reducers.hasOwnProperty(segmentName)) continue;
        if (!this._segmentClasses.hasOwnProperty(segmentName)) continue;
        reducer = this._reducers[segmentName];
        segment = this._segmentClasses[segmentName];
        segmentState = state[segmentName];
        nextSegmentState = reducer(segmentState, action);
        isChanged = isChanged || !segment.isStateEqual(segmentState, nextSegmentState);
        nextState[segmentName] = nextSegmentState;}

      return isChanged ? nextState : state;}


    /**
     * We need to watch out because _handleChange() could be recursive. For more
     * information please see _setPreviousState().
     *
     * @private
     */ }, { key: '_handleChange', value: 
    function _handleChange() {
      var handleChangeCallId = this._handleChangeCallId;
      if (_soyaLibScope2['default'].server) {
        // We don't need to trigger any subscription callback at server. We'll
        // render twice and we're only interested in the HTML string.
        return;}


      var state = this._getState();

      // Assume comparison is cheaper than re-rendering. We do way more comparison
      // when we compare each piece, with the benefits of not doing unnecessary
      // re-rendering.
      var segmentId, segment, segmentState, segmentSubscribers, queryId, 
      querySubscribers, subscriberId, queryResult, segmentPiece, query, callback, 
      curSegmentState, curQueryResult, cacheCurSegmentState, 
      cacheShouldUpdate;
      for (segmentId in this._segmentClasses) {
        if (!this._segmentClasses.hasOwnProperty(segmentId)) continue;
        segment = this._segmentClasses[segmentId];
        segmentSubscribers = this._subscribers[segmentId];
        for (queryId in segmentSubscribers) {
          if (!segmentSubscribers.hasOwnProperty(queryId)) continue;
          query = this._queries[segmentId][queryId].query;
          querySubscribers = segmentSubscribers[queryId];

          // Latest segment piece.
          segmentState = state[segmentId];
          queryResult = this._queryStateWithSegment(segmentId, query, queryId, segmentState);
          segmentPiece = queryResult.data;

          // Prepare cache in iterating subscribers. We cache to prevent
          // unnecessary querying of segment piece and comparison. Even though
          // order isn't guaranteed in objects, we assume that most
          // implementations should have consistent ordering when iterating so
          // that caching result from previous iteration would be useful.
          cacheCurSegmentState = null;
          cacheShouldUpdate = null;

          for (subscriberId in querySubscribers) {
            if (!querySubscribers.hasOwnProperty(subscriberId)) continue;
            callback = querySubscribers[subscriberId].callback;
            curSegmentState = querySubscribers[subscriberId].curSegmentState;

            // Don't need to query segment piece and compare if segment state of previous
            // iteration is the same.
            if (cacheShouldUpdate === null || cacheCurSegmentState !== curSegmentState) {
              cacheCurSegmentState = curSegmentState;
              curQueryResult = segment.queryState(query, queryId, curSegmentState);
              cacheShouldUpdate = curQueryResult.data !== segmentPiece;}


            this._subscribers[segmentId][queryId][subscriberId].curSegmentState = 
            segmentState;

            if (cacheShouldUpdate) {
              callback(segmentPiece);
              // Stop if recursive handleChange() call has happened.
              if (handleChangeCallId != this._handleChangeCallId) {
                // TODO: Only log when debug is set to true!
                console.log('Recursive handleChange() detected, cancelling update..', state);
                return;}}}}}






      // Increase ID so that recursive handleChange() can stop itself from
      // updating. One cycle of handleChange() call will iterate through all
      // subscribers so we no longer need previous handleChange() in stack
      // to continue.
      ++this._handleChangeCallId;}


    /**
     * @param {?Hydration} hydration
     * @return {Hydration}
     */ }, { key: '_initHydrationOption', value: 
    function _initHydrationOption(hydration) {
      if (hydration == null) return _HydrationJs2['default'].hydrateAtServer(0);
      return hydration;}


    /**
     * @param {string} segmentId
     * @param {any} query
     * @param {string} queryId
     * @returns {Object}
     */ }, { key: '_getSegmentPiece', value: 
    function _getSegmentPiece(segmentId, query, queryId) {
      var queryResult = this._queryState(segmentId, query, queryId);
      return queryResult.data;}


    /**
     * @param {string} segmentId
     * @param {any} query
     * @param {string} queryId
     * @returns {QueryResult}
     */ }, { key: '_queryState', value: 
    function _queryState(segmentId, query, queryId) {
      var state = this._store.getState();
      var segmentState = state[segmentId];
      return this._queryStateWithSegment(segmentId, query, queryId, segmentState);} }, { key: '_queryStateWithSegment', value: 


    function _queryStateWithSegment(segmentId, query, queryId, segmentState) {
      var queryResult = this._segmentClasses[segmentId].queryState(query, queryId, segmentState);
      if (queryResult.constructor != _QueryResultJs2['default']) throw new Error('Segment.queryState must return instance of QueryResult! queryId: ' + queryId);
      return queryResult;}


    /**
     * @param {string} segmentName
     * @param {string} queryId
     * @param {string} subscriberId
     */ }, { key: '_unsubscribe', value: 
    function _unsubscribe(segmentName, queryId, subscriberId) {
      delete this._subscribers[segmentName][queryId][subscriberId];}


    /**
     * Implements this by creating an allowSegmentOverwrite flag for all segments
     * that has been registered in this instance. If it was a new Segment, we
     * don't care since there won't be any conflict anyway.
     */ }, { key: '_mayHotReloadSegments', value: 
    function _mayHotReloadSegments() {
      this._allowOverwriteSegment = {};
      var segmentName;
      for (segmentName in this._segmentClasses) {
        if (!this._segmentClasses.hasOwnProperty(segmentName)) continue;
        this._allowOverwriteSegment[segmentName] = true;}}



    /**
     * @returns {boolean}
     */ }, { key: '_shouldRenderBeforeServerHydration', value: 
    function _shouldRenderBeforeServerHydration() {
      // We need to all segments to be registered first.
      return true;}


    /**
     * Runs hydration, depending on rendering type and hydration option. This
     * method is run twice, at server and at client side. Server side hydration
     * carries over to client side, so when we reinitialize everything at client
     * side, we'll run this method again to load queries that was specified to
     * only not to hydrate at server side.
     *
     * NOTE: Hydration is only done once per subscription. It's safe to call this
     * method more than once, anytime - to make sure that all registered state is
     * hydrated.
     *
     * @return {Promise}
     */ }, { key: 'hydrate', value: 
    function hydrate() {
      this._inHydration = true;
      var segment, segmentId, queryId, queries, hydration;
      var hydrationPromises = [], promise, query;
      for (segmentId in this._queries) {
        if (!this._queries.hasOwnProperty(segmentId)) continue;
        segment = this._segmentClasses[segmentId];
        if (!segment.shouldHydrate()) {
          // No need to hydrate local segments.
          continue;}

        queries = this._queries[segmentId];
        for (queryId in queries) {
          if (!queries.hasOwnProperty(queryId)) continue;
          hydration = queries[queryId].hydration;
          query = queries[queryId].query;

          // Don't need to do anything if it's already loaded.
          var queryResult = this._queryState(segmentId, query, queryId);
          if (queryResult.loaded) continue;

          var shouldLoad = 
          _soyaLibScope2['default'].client || 
          _soyaLibScope2['default'].server && hydration.shouldHydrateAtServer();


          if (shouldLoad) {
            promise = this._query(segment, segmentId, query, queryId, false);
            hydrationPromises.push(promise);}}}



      return _PromiseUtilJs2['default'].allParallel(Promise, hydrationPromises);}


    /**
     * Registers Segment to ReduxStore. ReduxStore splits the single state of
     * redux into multiple 'segments', each with their own action creator and
     * reducer. This is because when you use an action creator to create actions,
     * almost all of the time you also need the reducer that can process that
     * action. Since Segment encompasses both action creator and reducer of a
     * specific part of the state, you can say that one Segment is responsible for
     * a part, or a 'segment' of the state, and nothing else.
     *
     * In this method, we:
     *
     * 1) Make sure that there's no Segment id clash. We split redux state using
     *    the segment id as keys, so if there are clashes of segment names we
     *    can end up having corrupt state because two reducers will be trying to
     *    update the same object.
     * 2) Allow multiple registration of the same Segment class. Since we enforce
     *    subscribing components to declare their segment dependencies, we'll have
     *    multiple components registering the same segments.
     * 3) Returning a StoreReference object that can be used by components. It
     *    contains the action creator for this Segment.
     * 4) Since Segment can have dependencies, this method will also registers
     *    the dependencies of the given Segment recursively.
     *
     * @param {Class<Segment>} SegmentClass
     * @return {Object<string, Function>} Action creator.
     */ }, { key: 'register', value: 
    function register(SegmentClass) {
      // First let's register all dependencies that this Segment class has.
      var i, dependencies = SegmentClass.getSegmentDependencies();
      for (i = 0; i < dependencies.length; i++) {
        this.register(dependencies[i]);}


      // Get the segment ID to see if we already have registered the segment.
      var id = SegmentClass.id();
      var RegisteredSegmentClass = this._segmentClasses[id];

      if (this._segmentClasses.hasOwnProperty(id)) {
        if (RegisteredSegmentClass === SegmentClass) {
          // Segment already registered.
          return RegisteredSegmentClass.getActionCreator();} else 
        {
          throw new Error('Segment name clash: ' + id + '.', RegisteredSegmentClass, SegmentClass);}}



      // Register segment.
      if (!RegisteredSegmentClass) {
        this._initSegment(SegmentClass);
        RegisteredSegmentClass = SegmentClass;} else 

      if (SegmentClass !== RegisteredSegmentClass) {
        if (this._allowOverwriteSegment[id]) {
          // TODO: Create a DEBUG flag using webpack so that we can silent logging in production? or..
          // TODO: Make two logger implementation, client and server, then use clientReplace accordingly.
          console.log('Replacing segment.. (this should not happen in production!)', RegisteredSegmentClass, SegmentClass);
          this._initSegment(SegmentClass);
          RegisteredSegmentClass = SegmentClass;} else 
        {
          throw new Error('Segment id clash! Claimed by ' + RegisteredSegmentClass + ' and ' + SegmentClass + ', with id: ' + id + '.');}}



      // No longer allow segment overwrites for this segment name.
      // We only allow segment overwrites for *first* registration.
      delete this._allowOverwriteSegment[id];

      return RegisteredSegmentClass.getActionCreator();}


    /**
     * @param {Class<Segment>} SegmentClass
     */ }, { key: '_initSegment', value: 
    function _initSegment(SegmentClass) {
      var id = SegmentClass.id();
      this._segmentClasses[id] = SegmentClass;
      this._reducers[id] = SegmentClass.getReducer();
      this._subscribers[id] = {};
      this._actionCreators[id] = SegmentClass.getActionCreator();
      this._registeredQueries[id] = {};
      this._serviceDependencies[id] = {};

      var i, serviceId, serviceClass, service, 
      serviceDeps = SegmentClass.getServiceDependencies();
      for (i = 0; i < serviceDeps.length; i++) {
        serviceClass = serviceDeps[i];
        serviceId = serviceClass.id();
        if (typeof serviceId != 'string') {
          throw new Error('Service dependencies must extend Service:' + serviceClass);}

        service = this.getService(serviceClass);
        this._serviceDependencies[id][serviceId] = service;}}



    /**
     * @param {string} segmentId
     * @return {{[key: string]: Service}}
     */ }, { key: 'getServiceDependencies', value: 
    function getServiceDependencies(segmentId) {
      return this._serviceDependencies[segmentId];}


    /**
     * Instantiate Service if not yet ready, return cache if already exists.
     *
     * @param {Service} ServiceClass
     */ }, { key: 'getService', value: 
    function getService(ServiceClass) {
      var id = ServiceClass.id(), service;
      if (this._serviceClasses.hasOwnProperty(id)) {
        if (this._serviceClasses[id] === ServiceClass) {
          return this._services[id];}

        // TODO: Find a way to make this hot-reload-able.
        throw new Error('Service id clash: ' + serviceId + ', between classes: ' + serviceClass + ' and ' + this._serviceClasses[serviceId]);}


      // If not available yet, instantiate.
      service = new ServiceClass(this._clientConfig, this._cookieJar);
      this._serviceClasses[id] = ServiceClass;
      this._services[id] = service;
      return service;}


    /**
     * @param {string} segmentId
     * @param {string} queryId
     * @param {any} query
     * @param {Hydration} hydration
     */ }, { key: '_initQuery', value: 
    function _initQuery(segmentId, queryId, query, hydration) {
      hydration = this._initHydrationOption(hydration);
      if (!this._queries.hasOwnProperty(segmentId)) {
        this._queries[segmentId] = {};}

      if (!this._queries[segmentId].hasOwnProperty(queryId)) {
        this._queries[segmentId][queryId] = {};}

      if (!this._queries[segmentId][queryId].hasOwnProperty('query')) {
        this._queries[segmentId][queryId].query = query;}

      if (this._queries[segmentId][queryId].hasOwnProperty('hydration')) {
        hydration = this._queries[segmentId][queryId].hydration.clash(hydration);}

      this._queries[segmentId][queryId].hydration = hydration;}


    /**
     * Executes the mutation, returns an object containing the original Mutation
     * promise, and another promise that resolves when all refresh requests is
     * done.
     *
     * Mutation works by having each Segment define their own refresh requests.
     * Since we don't want to refresh anything if there's nothing loaded in the
     * segment state, we ask the Segment, providing their current segment state,
     * to tell us which query we need to re-run.
     *
     * TODO: Need to figure out how to handle mutation at server side.
     *
     * @param {Mutation} mutation
     * @return {{mutation: Promise; refresh: Promise}}
     */ }, { key: 'execute', value: 
    function execute(mutation) {var _this = this;
      var mutationPromise = mutation.execute();
      var refreshPromise = new Promise(function (resolve, reject) {
        mutationPromise.then(function (refreshRequestMap) {
          if (refreshRequestMap == null) resolve();
          var segmentId, i, segment, segmentState, queryList, state = _this._getState();
          var promiseList = [];
          for (segmentId in refreshRequestMap) {
            if (!refreshRequestMap.hasOwnProperty(segmentId) || 
            !_this._segmentClasses.hasOwnProperty(segmentId)) {
              continue;}

            segment = _this._segmentClasses[segmentId];
            segmentState = state[segmentId];
            queryList = segment.processRefreshRequests(
            segmentState, refreshRequestMap[segmentId]);
            for (i = 0; i < queryList.length; i++) {
              promiseList.push(_this.query(segmentId, queryList[i], true));}

            _PromiseUtilJs2['default'].allParallel(Promise, promiseList).then(resolve, reject)['catch'](function (error) {
              reject(error);
              _PromiseUtilJs2['default'].throwError(error);});}}, 


        reject)['catch'](function (error) {
          reject(error);
          _PromiseUtilJs2['default'].throwError(error);});});


      return { 
        mutation: mutationPromise, 
        refresh: refreshPromise };}



    /**
     * Subscribes the given callback against the a specific query to a specific
     * segment. When the state changes, ReduxStore will ask the Segment to
     * determine if the query result has changed. If the query result has changed,
     * the callback will be run.
     *
     * Hydration option
     *
     * @param {string} segmentId
     * @param {any} query
     * @param {Function} callback
     * @param {any} component
     * @param {?Hydration} hydration
     * @return {StoreReference}
     */ }, { key: 'subscribe', value: 
    function subscribe(segmentId, query, callback, component, hydration) {
      // Determine subscriber ID.
      var subscriberId = component[SUBSCRIBER_ID];
      if (!subscriberId) {
        // Yay for not having to deal with concurrency :)
        subscriberId = this._nextSubscriberId++;
        component[SUBSCRIBER_ID] = subscriberId;}


      var segment = this._segmentClasses[segmentId];
      if (!segment) {
        throw new Error('Cannot subscribe, Segment is not registered: ' + segmentId + '.');}


      // TODO: We call generateQueryId twice on subscribe, fix.
      var queryId = segment.generateQueryId(query);

      // Runs the query (if we're at server, the query won't actually be run).
      // Server side queries will be run through hydrate() method.
      var subscribePromise = this.query(segmentId, query, false, hydration);
      subscribePromise['catch'](_PromiseUtilJs2['default'].throwError);
      var segmentState = this._getState()[segmentId];

      // Register subscriber.
      if (!this._subscribers[segmentId][queryId]) this._subscribers[segmentId][queryId] = {};
      this._subscribers[segmentId][queryId][subscriberId] = { 
        callback: callback, 
        curSegmentState: segmentState };


      var result = { 
        getState: this._getSegmentPiece.bind(this, segmentId, query, queryId), 
        unsubscribe: this._unsubscribe.bind(this, segmentId, queryId, subscriberId) };

      return result;}


    /**
     * Creates the load action that fetches data. Returns Promise that resolves
     * with the newly stored Segment piece.
     *
     * @param {string} segmentId
     * @param {any} query
     * @param {?boolean} forceLoad
     * @param {?Hydration} hydration
     * @return {Promise}
     */ }, { key: 'query', value: 
    function query(segmentId, _query, forceLoad, hydration) {
      var segment = this._segmentClasses[segmentId];
      if (!segment) {
        throw new Error('Cannot query, Segment is not registered: ' + segmentId + '.');}


      // TODO: When we turn on history navigation, this._queries map will pile up, causing memory leak. Fix.
      var queryId = segment.generateQueryId(_query);
      this._initQuery(segmentId, queryId, _query, hydration);
      hydration = this._queries[segmentId][queryId].hydration;

      if (_soyaLibScope2['default'].server && !this._inHydration || 
      _soyaLibScope2['default'].server && !hydration.shouldHydrateAtServer()) {
        // If at server, returns a promise that never resolves. Querying in server
        // will be done via an explicit hydrate() method. This reduces unnecessary
        // execution of code at our server, ensuring no surprises when dealing
        // with configuration option.
        return new Promise(function () {});}


      return this._query(segment, segmentId, _query, queryId, forceLoad);} }, { key: '_query', value: 


    function _query(segment, segmentId, query, queryId, forceLoad) {var _this2 = this;
      // If already loaded, return immediately.
      var queryResult = this._queryState(segmentId, query, queryId);
      if (queryResult.loaded && !forceLoad) {
        return Promise.resolve(queryResult.data);}


      // TODO: We should be able to reuse this get segment piece function.
      var getSegmentPiece = function getSegmentPiece() {
        return _this2._getSegmentPiece(segmentId, query, queryId);};


      // Re-use promise from another dispatch to prevent double fetching.
      if (!forceLoad && this._queries[segmentId][queryId].promise) {
        return this._queries[segmentId][queryId].promise.then(getSegmentPiece);}


      // Right now either segment isn't loaded yet or this is a force load.
      // So we ask Segment to load the query.
      var state = this._store.getState();
      var segmentState = state[segmentId];
      var services = this.getServiceDependencies(segmentId);
      var loadAction = segment.createLoadFromQuery(query, queryId, segmentState, services);
      if (loadAction == null) {
        // If load action is null, then this segment doesn't need to do load
        // actions. We return immediately with previously fetched segment piece.
        return Promise.resolve(queryResult.data);}


      // Cache the load promise so multiple same queries will only result in
      // one load action, saving user's bandwidth. If the user dispatches the
      // load action directly, the promise won't get cached, so make sure to
      // mention to the user to use query to load data whenever possible.
      var loadPromise = this.dispatch(loadAction);
      this._queries[segmentId][queryId].promise = loadPromise;

      // Return a promise that resolves with the segment piece.
      return loadPromise.then(getSegmentPiece);}


    /**
     * @param {any} component
     */ }, { key: 'unsubscribe', value: 
    function unsubscribe(component) {
      var componentSubscriberId = component[SUBSCRIBER_ID];
      var segmentName, queryId, subscriberId;
      var unsubscribeList = [];
      for (segmentName in this._subscribers) {
        if (!this._subscribers.hasOwnProperty(segmentName)) continue;
        for (queryId in this._subscribers[segmentName]) {
          if (!this._subscribers[segmentName].hasOwnProperty(queryId)) continue;
          for (subscriberId in this._subscribers[segmentName][queryId]) {
            if (!this._subscribers[segmentName][queryId].hasOwnProperty(subscriberId)) continue;
            if (subscriberId == componentSubscriberId) {
              unsubscribeList.push([segmentName, queryId, componentSubscriberId]);}}}}





      var i;
      for (i = 0; i < unsubscribeList.length; i++) {
        this._unsubscribe(unsubscribeList[i][0], unsubscribeList[i][1], unsubscribeList[i][2]);}}



    /**
     * Returns a Promise that is resolved when the action is dispatched
     * to all reducers.
     *
     * If the given action is an Object, its dispatch will be sync, so a Promise
     * that resolves immediately is given.
     *
     * If the given action is a thunk function, it will check if the function
     * returns a Promise or not. If not, it will throw an error. Otherwise the
     * Promise is returned.
     *
     * @param {Load | Object} action
     * @return {Promise}
     */ }, { key: 'dispatch', value: 
    function dispatch(action) {var _this3 = this;
      // No need to do anything if the action is null/undefined. This is a pattern
      // used when Segments don't need to do init or load actions.
      if (action == null) {
        return Promise.resolve(null);}


      var result;
      if (action instanceof _LoadJs2['default']) {
        // Immediately create a promise so we can ensure no identical fetching
        // can happen at the same time with query() or subscribe().
        return new Promise(function (resolve, reject) {
          // Resolve dependencies first.
          var depResolvedPromise = Promise.resolve(null);
          if (action.dependencies instanceof _QueryDependenciesJs2['default']) {
            depResolvedPromise = action.dependencies._run(_this3);}


          // After dependencies are resolved, run the thunk function. The thunk
          // function should still have reference to QueryDependencies, allowing
          // it to access its dependencies' query results.
          depResolvedPromise.then(function () {
            result = action.func(
            _this3._boundDispatch, _this3._boundQuery, 
            _this3.getServiceDependencies(action.segmentId));

            _this3._ensurePromise(result);
            result.then(resolve)['catch'](reject);})['catch'](
          reject);});}



      this._store.dispatch(action);
      return Promise.resolve(null);}


    /**
     * @param {Promise} promise
     */ }, { key: '_ensurePromise', value: 
    function _ensurePromise(promise) {
      if (promise == null || typeof promise.then != 'function') {
        throw new Error('Expected Promise from async action creator, got this instead: ' + promise + '.');}}



    /**
     * @returns {any}
     */ }, { key: '_getState', value: 
    function _getState() {
      return this._store.getState();}


    /**
     * Can be used to instantly reproducing extracted state. Useful for generating
     * test cases or reproducing customer bugs.
     *
     * IMPORTANT: Calling this method may cause mismatch between redux store and
     * registered segments. You should only call this when you know what you're
     * doing.
     *
     * @param {any} newState
     */ }, { key: '_replaceState', value: 
    function _replaceState(newState) {
      this._store.dispatch({ 
        type: REPLACE_STATE, 
        state: newState });}



    /**
     * Returns current timestamp.
     *
     * @returns {number}
     */ }, { key: '_getTimestamp', value: 
    function _getTimestamp() {
      return Date.now ? Date.now() : new Date().getTime();} }]);return ReduxStore;})(_StoreJs2['default']);exports['default'] = ReduxStore;module.exports = exports['default']; /**
                                                                                                                                                                                 * @type {boolean}
                                                                                                                                                                                 */ /**
                                                                                                                                                                                     * @type {number}
                                                                                                                                                                                     */ /**
                                                                                                                                                                                         * @type {{[key: string]: Class<Segment>}}
                                                                                                                                                                                         */ /**
                                                                                                                                                                                             * @type {{[key: string]: Service}}
                                                                                                                                                                                             */ /**
                                                                                                                                                                                                 * @type {{[key: string]: Class<Service>}}
                                                                                                                                                                                                 */ /**
                                                                                                                                                                                                     * @type {{[key: string]: Array<Service>}}
                                                                                                                                                                                                     */ /**
                                                                                                                                                                                                         * <pre>
                                                                                                                                                                                                         *   {
                                                                                                                                                                                                         *     segmentId: {
                                                                                                                                                                                                         *       queryId: {
                                                                                                                                                                                                         *         promise: thenable,
                                                                                                                                                                                                         *         query: any
                                                                                                                                                                                                         *       }
                                                                                                                                                                                                         *     }
                                                                                                                                                                                                         *   }
                                                                                                                                                                                                         * </pre>
                                                                                                                                                                                                         *
                                                                                                                                                                                                         * @type {{[key: string]: {[key: string]: { promise: ?Promise, query: any }}}}
                                                                                                                                                                                                         */ /**
                                                                                                                                                                                                             * <pre>
                                                                                                                                                                                                             *   {
                                                                                                                                                                                                             *     segmentId: {
                                                                                                                                                                                                             *       queryId: {
                                                                                                                                                                                                             *         subscriberId: {
                                                                                                                                                                                                             *           callback: callbackFunc,
                                                                                                                                                                                                             *           curSegmentState: {...}
                                                                                                                                                                                                             *         },
                                                                                                                                                                                                             *         subscriberId: {
                                                                                                                                                                                                             *           callback: callbackFunc,
                                                                                                                                                                                                             *           curSegmentState: {...}
                                                                                                                                                                                                             *         }
                                                                                                                                                                                                             *       }
                                                                                                                                                                                                             *     }
                                                                                                                                                                                                             *   }
                                                                                                                                                                                                             * </pre>
                                                                                                                                                                                                             *
                                                                                                                                                                                                             * @type {{[key: string]: {[key: string]: {[key: string]: Function}}}}
                                                                                                                                                                                                             */ /**
                                                                                                                                                                                                                 * <pre>
                                                                                                                                                                                                                 *   {
                                                                                                                                                                                                                 *     segmentId: function() {...},
                                                                                                                                                                                                                 *     segmentId: function() {...}
                                                                                                                                                                                                                 *   }
                                                                                                                                                                                                                 * </pre>
                                                                                                                                                                                                                 *
                                                                                                                                                                                                                 * @type {{[key: string]: Function}}
                                                                                                                                                                                                                 */ /**
                                                                                                                                                                                                                     * <pre>
                                                                                                                                                                                                                     *   {
                                                                                                                                                                                                                     *     segmentId: {...},
                                                                                                                                                                                                                     *     segmentId: {...}
                                                                                                                                                                                                                     *   }
                                                                                                                                                                                                                     * </pre>
                                                                                                                                                                                                                     *
                                                                                                                                                                                                                     * @type {{[key: string]: Object}}
                                                                                                                                                                                                                     */ /**
                                                                                                                                                                                                                         * Redux store.
                                                                                                                                                                                                                         *
                                                                                                                                                                                                                         * @type {any}
                                                                                                                                                                                                                         */ /**
                                                                                                                                                                                                                             * @type {{[key: string]: boolean}}
                                                                                                                                                                                                                             */ /**
                                                                                                                                                                                                                                 * @type {{[key: string]: boolean}}
                                                                                                                                                                                                                                 */ /**
                                                                                                                                                                                                                                     * @type {boolean}
                                                                                                                                                                                                                                     */ /**
                                                                                                                                                                                                                                         * @type {Object}
                                                                                                                                                                                                                                         */ /**
                                                                                                                                                                                                                                             * @type {CookieJar}
                                                                                                                                                                                                                                             */ /**
                                                                                                                                                                                                                                                 * @type {Function}
                                                                                                                                                                                                                                                 */ /**
                                                                                                                                                                                                                                                     * @type {Function}
                                                                                                                                                                                                                                                     */ /**
                                                                                                                                                                                                                                                         * @type {number}
                                                                                                                                                                                                                                                         */ /**
                                                                                                                                                                                                                                                             * @type {boolean}
                                                                                                                                                                                                                                                             */
//# sourceMappingURL=ReduxStore.js.map