'use strict';Object.defineProperty(exports, '__esModule', { value: true });exports['default'] = 





























server;function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}var _path = require('path');var _path2 = _interopRequireDefault(_path);var _jsYaml = require('js-yaml');var _jsYaml2 = _interopRequireDefault(_jsYaml);var _fs = require('fs');var _fs2 = _interopRequireDefault(_fs);var _webpack = require('webpack');var _webpack2 = _interopRequireDefault(_webpack);var _react = require('react');var _react2 = _interopRequireDefault(_react);var _routerRouterJs = require('../router/Router.js');var _routerRouterJs2 = _interopRequireDefault(_routerRouterJs);var _routerReverseRouterJs = require('../router/ReverseRouter.js');var _routerReverseRouterJs2 = _interopRequireDefault(_routerReverseRouterJs);var _routerDomainNodeJs = require('../router/DomainNode.js');var _routerDomainNodeJs2 = _interopRequireDefault(_routerDomainNodeJs);var _routerMethodNodeJs = require('../router/MethodNode.js');var _routerMethodNodeJs2 = _interopRequireDefault(_routerMethodNodeJs);var _routerPathNodeJs = require('../router/PathNode.js');var _routerPathNodeJs2 = _interopRequireDefault(_routerPathNodeJs);var _routerNodeFactoryJs = require('../router/NodeFactory.js');var _routerNodeFactoryJs2 = _interopRequireDefault(_routerNodeFactoryJs);var _ComponentRegisterJs = require('../ComponentRegister.js');var _ComponentRegisterJs2 = _interopRequireDefault(_ComponentRegisterJs);var _compilerWebpackWebpackCompilerJs = require('../compiler/webpack/WebpackCompiler.js');var _compilerWebpackWebpackCompilerJs2 = _interopRequireDefault(_compilerWebpackWebpackCompilerJs);var _defaultFrameworkConfigJs = require('../defaultFrameworkConfig.js');var _ApplicationJs = require('../Application.js');var _ApplicationJs2 = _interopRequireDefault(_ApplicationJs);var _precompilePrecompilerJs = require('../precompile/Precompiler.js');var _precompilePrecompilerJs2 = _interopRequireDefault(_precompilePrecompilerJs); // These dependencies can all be overwritten by user.
var _registerRouterNodesJs = require('./registerRouterNodes.js');var _registerRouterNodesJs2 = _interopRequireDefault(_registerRouterNodesJs);var _createLoggerJs = require('./createLogger.js');var _createLoggerJs2 = _interopRequireDefault(_createLoggerJs);var _createErrorHandlerJs = require('./createErrorHandler.js');var _createErrorHandlerJs2 = _interopRequireDefault(_createErrorHandlerJs); /**
                                                                                                                                                                                                                                                                                                                                                                                                            * @param {Object} config
                                                                                                                                                                                                                                                                                                                                                                                                            * @param {Object} pages
                                                                                                                                                                                                                                                                                                                                                                                                            * @param {Object} components
                                                                                                                                                                                                                                                                                                                                                                                                            * @SERVER
                                                                                                                                                                                                                                                                                                                                                                                                            */function server(config, pages) {var frameworkConfig = config.frameworkConfig;var serverConfig = config.serverConfig;var clientConfig = config.clientConfig;frameworkConfig = Object.assign({}, _defaultFrameworkConfigJs.DEFAULT_FRAMEWORK_CONFIG, frameworkConfig);var createLogger = _createLoggerJs2['default'];
  var createErrorHandler = _createErrorHandlerJs2['default'];
  var registerRouterNodes = _registerRouterNodesJs2['default'];

  // Load custom logger and error handler factory.
  if (typeof frameworkConfig.loggerFactoryFunction == 'function') {
    createLogger = frameworkConfig.loggerFactoryFunction;}

  if (typeof frameworkConfig.errorHandlerFactoryFunction == 'function') {
    createErrorHandler = frameworkConfig.errorHandlerFactorFunction;}

  if (typeof frameworkConfig.routerNodeRegistrationFunction == 'function') {
    if (!frameworkConfig.routerNodeRegistrationAbsolutePath) {
      throw new Error('You must set both routerNodeRegistrationFunction and routerNodeRegistrationFilePath to register your custom router nodes.');}

    registerRouterNodes = frameworkConfig.routerNodeRegistrationFunction;}


  var logger = createLogger(serverConfig);
  var errorHandler = createErrorHandler(serverConfig, logger);
  var nodeFactory = new _routerNodeFactoryJs2['default']();
  var pageName, handlerRegister = new _ComponentRegisterJs2['default'](logger);

  // Register all pages to handler register.
  for (pageName in pages) {
    handlerRegister.regPage(
    pageName, _path2['default'].join(frameworkConfig.absoluteProjectDir, pageName), 
    pages[pageName]);}



  // Register default nodes for router.
  nodeFactory.registerNodeType(_routerDomainNodeJs2['default']);
  nodeFactory.registerNodeType(_routerMethodNodeJs2['default']);
  nodeFactory.registerNodeType(_routerPathNodeJs2['default']);

  // Load custom router nodes and create router.
  registerRouterNodes(nodeFactory);
  var router = new _routerRouterJs2['default'](logger, nodeFactory, handlerRegister);
  var reverseRouter = new _routerReverseRouterJs2['default'](nodeFactory);

  if (frameworkConfig.componentBrowser) {
    // Register component browser routes.
    router.reg('CMPT_BROWSER_LIST', { 
      page: _precompilePrecompilerJs2['default'].getCmptBrowserListPageRelativePath(), 
      nodes: [
      ['method', 'GET'], 
      ['path', '/component-browser']] });}




  // Load routes.
  var routes = _jsYaml2['default'].safeLoad(_fs2['default'].readFileSync(_path2['default'].join(config.frameworkConfig.absoluteProjectDir, 'routes.yml'), 'utf8'));
  var routeId;
  for (routeId in routes) {
    router.reg(routeId, routes[routeId]);
    reverseRouter.reg(routeId, routes[routeId]);}


  // If not found page is not set up.
  if (!router.getNotFoundRouteResult()) {
    throw new Error('404 not found page not registered! Please create a 404 not found page.');}


  // Load websocket routes.
  var websocketOption = null;

  if (frameworkConfig.webSocket.enabled === true) {
    var wsComponentRegister = new _ComponentRegisterJs2['default'](logger);
    var wsPageRequireContext = frameworkConfig.webSocketPageRequireContext;
    var wsPageRequirePath = frameworkConfig.webSocketAbsolutePageRequirePath;

    finder.find(wsPageRequirePath, function (vendor, name, absDir, relativeDir) {
      wsComponentRegister.regPage(name, absDir, wsPageRequireContext('./' + _path2['default'].join(relativeDir, name + '.js')));});


    // Load custom router nodes and create router.
    var wsRouter = new _routerRouterJs2['default'](logger, nodeFactory, wsComponentRegister);
    var wsReverseRouter = new _routerReverseRouterJs2['default'](nodeFactory);

    // Load routes.
    var wsRoutes = _jsYaml2['default'].safeLoad(_fs2['default'].readFileSync(frameworkConfig.webSocketRoutesFilePath, 'utf8'));
    var wsRouteId;

    for (wsRouteId in wsRoutes) {
      if (!wsRoutes.hasOwnProperty(wsRouteId)) continue;
      wsRouter.reg(wsRouteId, wsRoutes[wsRouteId]);
      wsReverseRouter.reg(wsRouteId, wsRoutes[wsRouteId]);}


    // If not found page is not set up.
    if (!router.getNotFoundRouteResult()) {
      throw new Error('404 not found page not registered! Please create a 404 not found page.');}


    websocketOption = { 
      componentRegister: wsComponentRegister, 
      routes: wsRoutes, 
      router: wsRouter, 
      reverseRouter: wsReverseRouter };}



  var webpackDevMiddleware;
  var webpackHotMiddleware;

  if (frameworkConfig.hotReload) {
    webpackDevMiddleware = require('webpack-dev-middleware');
    webpackHotMiddleware = require('webpack-hot-middleware');}


  var compiler = new _compilerWebpackWebpackCompilerJs2['default'](
  logger, frameworkConfig, _webpack2['default'], _react2['default'], 
  webpackDevMiddleware, webpackHotMiddleware);

  var application = new _ApplicationJs2['default'](
  logger, handlerRegister, routes, router, reverseRouter, errorHandler, compiler, 
  frameworkConfig, serverConfig, clientConfig, websocketOption);

  application.start();}module.exports = exports['default'];
//# sourceMappingURL=index.js.map